
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Ai_recommendationsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const ai_recommendations = await db.ai_recommendations.create(
            {
                id: data.id || undefined,
        
        generated_at: data.generated_at
        ||
        null
            ,
            
        recommendation_type: data.recommendation_type
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        estimated_risk_reduction: data.estimated_risk_reduction
        ||
        null
            ,
            
        title: data.title
        ||
        null
            ,
            
        details: data.details
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await ai_recommendations.setOrganization(currentUser.organization.id || null, {
            transaction,
        });
        
        await ai_recommendations.setIncident( data.incident || null, {
            transaction,
        });
        
        await ai_recommendations.setModel( data.model || null, {
            transaction,
        });
        

        

        

        return ai_recommendations;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const ai_recommendationsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                generated_at: item.generated_at
            ||
            null
            ,
            
                recommendation_type: item.recommendation_type
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                estimated_risk_reduction: item.estimated_risk_reduction
            ||
            null
            ,
            
                title: item.title
            ||
            null
            ,
            
                details: item.details
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const ai_recommendations = await db.ai_recommendations.bulkCreate(ai_recommendationsData, { transaction });

        // For each item created, replace relation files
        

        return ai_recommendations;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const ai_recommendations = await db.ai_recommendations.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.generated_at !== undefined) updatePayload.generated_at = data.generated_at;
        
        
        if (data.recommendation_type !== undefined) updatePayload.recommendation_type = data.recommendation_type;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.estimated_risk_reduction !== undefined) updatePayload.estimated_risk_reduction = data.estimated_risk_reduction;
        
        
        if (data.title !== undefined) updatePayload.title = data.title;
        
        
        if (data.details !== undefined) updatePayload.details = data.details;
        
        
        updatePayload.updatedById = currentUser.id;

        await ai_recommendations.update(updatePayload, {transaction});

        
        
        if (data.organization !== undefined) {
            await ai_recommendations.setOrganization(
              
              (globalAccess ? data.organization : currentUser.organization.id),
              
              { transaction }
            );
        }
        
        if (data.incident !== undefined) {
            await ai_recommendations.setIncident(
              
              data.incident,
              
              { transaction }
            );
        }
        
        if (data.model !== undefined) {
            await ai_recommendations.setModel(
              
              data.model,
              
              { transaction }
            );
        }
        

        
        

        

        return ai_recommendations;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const ai_recommendations = await db.ai_recommendations.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of ai_recommendations) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of ai_recommendations) {
                await record.destroy({transaction});
            }
        });


        return ai_recommendations;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const ai_recommendations = await db.ai_recommendations.findByPk(id, options);

        await ai_recommendations.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await ai_recommendations.destroy({
            transaction
        });

        return ai_recommendations;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const ai_recommendations = await db.ai_recommendations.findOne(
            { where },
            { transaction },
        );

        if (!ai_recommendations) {
            return ai_recommendations;
        }

        const output = ai_recommendations.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.organization = await ai_recommendations.getOrganization({
            transaction
        });
        
        
        output.incident = await ai_recommendations.getIncident({
            transaction
        });
        
        
        output.model = await ai_recommendations.getModel({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.organizations,
        as: 'organization',
        
      },

      {
        model: db.incidents,
        as: 'incident',
        
        where: filter.incident ? {
          [Op.or]: [
            { id: { [Op.in]: filter.incident.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.incident.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.ai_models,
        as: 'model',
        
        where: filter.model ? {
          [Op.or]: [
            { id: { [Op.in]: filter.model.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.model.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.title) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'ai_recommendations',
                        'title',
                        filter.title,
                    ),
                };
            }
            
            if (filter.details) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'ai_recommendations',
                        'details',
                        filter.details,
                    ),
                };
            }
            

            
            

            
            if (filter.generated_atRange) {
                const [start, end] = filter.generated_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    generated_at: {
                    ...where.generated_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    generated_at: {
                    ...where.generated_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.estimated_risk_reductionRange) {
                const [start, end] = filter.estimated_risk_reductionRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    estimated_risk_reduction: {
                    ...where.estimated_risk_reduction,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    estimated_risk_reduction: {
                    ...where.estimated_risk_reduction,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.recommendation_type) {
                where = {
                    ...where,
                recommendation_type: filter.recommendation_type,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      
      if (filter.organization) {
        const listItems = filter.organization.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationId: {[Op.or]: listItems}
        };
      }
      

      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.ai_recommendations.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'ai_recommendations',
                        'title',
                        query,
                    ),
                ],
            };
        }

        const records = await db.ai_recommendations.findAll({
            attributes: [ 'id', 'title' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['title', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.title,
        }));
    }

    
};

